#include "StdAfx.h"
#include "UpgraderView.h"
#include "Resource.h"
#include "Application.h"
#include "UpgraderModel.h"
#include "../resource.h"

extern HMODULE _hModule;
namespace tipupgrader
{

UpgraderView::UpgraderView(void):TipView(_T("tip_upgrader_main")/*_T("tip_pad_main")*/),m_bInitSilent(TRUE)
{
	m_WindowPos.x = 0xffffffff;
	m_WindowPos.y = 0xffffffff;
	m_singletonDialog = NULL;
}

UpgraderView::~UpgraderView(void)
{
}

void UpgraderView::RecalcLayout()
{
	CComponent* content = this->FindName(_T("content"));
	if (content)
	{
		content->RecalcLayout(TRUE);
		content->Invalidate();
	}
}
void UpgraderView::Init()
{
//	if (m_bInitSilent == FALSE)
//	{
//		__super::Init();
//	}
//	m_bInitSilent = FALSE;

	SetIcon();
}
void UpgraderView::SetIcon()
{
	HICON hIcon = LoadIcon(_hModule, MAKEINTRESOURCE(IDI_TIPUPGRADER));
	HICON hSmallIcon = LoadIcon(_hModule, MAKEINTRESOURCE(IDI_SMALL));
	CRootWindow* rootWindow = GetMainWindow();
	if ( rootWindow != NULL)
	{
		HWND hWndMain = rootWindow->GetWindow();
		if (::IsWindow(hWndMain))
		{
			SendMessage(GetMainWindow()->GetWindow(), WM_SETICON, ICON_BIG, (LPARAM)hIcon);
			SendMessage(GetMainWindow()->GetWindow(), WM_SETICON, ICON_SMALL, (LPARAM)hSmallIcon);
		}
	}
}

HWND UpgraderView::GetActiveWindow(BOOL bMainWindow)
{
	CRootWindow* rootWindow = GetMainWindow();
	if (rootWindow)
	{
		CRootContainer* rootContainer = rootWindow->GetRootContainer();
		if (rootContainer)
		{
			if (rootContainer->IsVisible())
			{
				HWND hMainView = rootWindow->GetWindow();
				HWND hPopupWnd = GetLastActivePopup(hMainView);
				HWND hOwner = GetWindow(hPopupWnd, GW_OWNER);
				// ˾ 찡  ̸ ˾ Ѵ.
				if (hOwner == hMainView && bMainWindow == FALSE) 
					return hPopupWnd;
				else
					return hMainView;
			}
		}
	}
	return GetDesktopWindow();
}

void UpgraderView::CloseMainWindow()
{
	CRootWindow* rootWindow = GetMainWindow();
	if (!rootWindow)
		return;

	CRootContainer* rootContainer = rootWindow->GetRootContainer();
	if (!rootContainer)
		return;

	HWND hWnd = rootWindow->GetWindow();
	if (!hWnd)
		return;

	RECT rect;
	GetWindowRect(hWnd, &rect);
	m_WindowPos.x = rect.left;
	m_WindowPos.y = rect.top;

	RECT rcVirtualArea;
	rcVirtualArea.left = rcVirtualArea.top = 0;
	rcVirtualArea.right  = ::GetSystemMetrics( SM_CXVIRTUALSCREEN );
	rcVirtualArea.bottom  = ::GetSystemMetrics( SM_CYVIRTUALSCREEN );
	//   ġ ʱȭ 
	if (rect.left < rcVirtualArea.left || rect.top < rcVirtualArea.top
		|| rcVirtualArea.right < rect.left || rcVirtualArea.bottom < rcVirtualArea.top)
	{
		m_WindowPos.x = 0xffffffff;
		m_WindowPos.y = 0xffffffff;
	}


	::DestroyWindow(hWnd);
//	rootContainer->Destroy();
	this->SetMainWindow(NULL);

}
BOOL UpgraderView::OpenMainWindow()
{
	BOOL bCreateMainWindow = FALSE;
	CRootWindow* rootWindow = GetMainWindow();
	if (rootWindow)
	{
		HWND hWnd = rootWindow->GetWindow();
		ShowWindow(hWnd, SW_SHOWNORMAL);
		SetForegroundWindow(GetActiveWindow());
	}
	else
	{
		// ġ/Ʈ ߿  並 ٽ   ʵ Ѵ.
		Application* application = Application::get_instance();
		UpgraderModel* upgraderModel = dynamic_cast<UpgraderModel*>(application->GetModel());
		//UpgraderDocument* document = upgraderModel->GetDocument();
		//if (NULL == document->GetPendingService())
		this->Init();
		bCreateMainWindow = TRUE;
		rootWindow = GetMainWindow();
		if (rootWindow)
		{
			if (m_WindowPos.x != 0xffffffff && m_WindowPos.y != 0xffffffff)
			{
				SetWindowPos(rootWindow->GetWindow(), NULL, m_WindowPos.x, m_WindowPos.y, -1, -1,
					SWP_NOSIZE | SWP_NOZORDER | SWP_NOACTIVATE);
			}
		}
	}

	return bCreateMainWindow;
}

BOOL UpgraderView::IsVisibleMainWindow()
{
	CRootWindow* rootWindow = GetMainWindow();
	if (!rootWindow)
		return FALSE;

	CRootContainer* rootConatiner = rootWindow->GetRootContainer();
	if (!rootConatiner)
		return FALSE;

	HWND hWnd = rootWindow->GetWindow();
	if (!hWnd)
		return FALSE;

	return rootConatiner->IsVisible();
}
void UpgraderView::Invalidate()
{
	CRootWindow* rootWindow = GetMainWindow();
	if (!rootWindow)
		return;

	CRootContainer* rootConatiner = rootWindow->GetRootContainer();
	if (!rootConatiner)
		return;

	rootConatiner->Invalidate();
}
};